scripts/cluster/apt.check.update.sh

370 lines
9.2 KiB
Bash
Raw Normal View History

#!/bin/sh
# This script will check if any APT upgrade is available and
# will prepare the host in order to apply upgrade with another script
# 1. Create a temp file
# 2. Disable SGE queue
# This script can be call by a cronjob (eg. weekly)
# Another script should try to apply upgrades also with cron (eg. hourly)
# Vars {{{
readonly PROGNAME=$(basename "${0}")
readonly PROGDIR=$(readlink -m $(dirname "${0}"))
readonly ARGS="${*}"
readonly NBARGS="${#}"
2020-09-24 15:18:09 +02:00
[ -z "${DEBUG}" ] && DEBUG=1
## Export DEBUG for sub-script
export DEBUG
readonly APT_TMP_FILE="/tmp/.apt.upgrade"
## Colors
readonly PURPLE='\033[1;35m'
readonly RED='\033[0;31m'
readonly RESET='\033[0m'
readonly COLOR_DEBUG="${PURPLE}"
# }}}
usage() { # {{{
cat <<- EOF
usage: $PROGNAME [-d|-e|-h]
Verify if any APT package upgrade is available and
try to prepare the host by:
* Disabling SGE queue
EXAMPLES:
- Verify upgrade and prepare the current host
${PROGNAME}
2020-09-24 15:18:09 +02:00
OPTIONS:
-d,--debug
Enable debug messages.
-e,--empty
Check APT upgrades only if SGE slots are empty
2020-09-24 15:18:09 +02:00
-h,--help
Print this help message.
EOF
}
# }}}
debug_message() { # {{{
local_message="${1}"
## Print message if DEBUG is enable (=0)
[ "${DEBUG}" -eq "0" ] && printf '\e[1;35m%-6b\e[m\n' "DEBUG ${PROGNAME}: ${local_message}"
return 0
}
# }}}
define_vars() { # {{{
## If sge_hostname wasn't defined (environment variable,…) {{{
if [ -z "${sge_hostname}" ]; then
## Use local host for sge_hostname
sge_hostname="$(hostname -f)"
fi
## }}}
## If EMPTY_ONLY_MODE wasn't defined (argument, environment variable,…) {{{
2020-12-04 08:36:04 +01:00
if [ -z "${EMPTY_ONLY_MODE}" ]; then
### Set False by default
EMPTY_ONLY_MODE="1"
fi
## }}}
2020-12-04 08:36:04 +01:00
## Script used to disable SGE queue(s)
sge_disable_host_queue_script="${PROGDIR}/sge.disable.host.queue.sh"
## Get the number of SGE used slots
sge_slots_used=$(qhost -h "${sge_hostname:=/dev/null}" -q -xml \
| grep --max-count=1 -- "'slots_used'" \
| sed 's;.*<queuevalue.*>\(.*\)</queuevalue>;\1;')
## SGE queues state file
cluster_dir="/opt/ipr/cluster"
sge_queue_flag_pattern="${cluster_dir}/.sge.*.disable"
2021-01-26 18:23:01 +01:00
}
# }}}
is_sge_host() { # {{{
## Check if SGE commands (qconf) are available
if [ "$(command -v qconf)" ]; then
2021-01-26 18:23:01 +01:00
debug_message "is_sge_host \
SGE seems present on this host."
### And verify if the host is fully configured as a submit host
if qconf -ss | grep --word-regexp --quiet $(hostname -f); then
debug_message "is_sge_host \
The host seems configured as a SGE submit host."
return_is_sge_host="0"
else
return_is_sge_host="1"
debug_message "is_sge_host \
This host is not yet configured as a SGE submit host."
fi
2021-01-26 18:23:01 +01:00
else
return_is_sge_host="1"
debug_message "is_sge_host \
SGE is not present on this host."
fi
return "${return_is_sge_host}"
}
# }}}
is_sge_master_available() { # {{{
## Check with Netcat if SGE master (sge_qmaster) is reachable from this host.
### -z: Only scan for listening daemons, without sending any data to them.
### -w 10: Timeout the test after 10 seconds.
if nc -z -w 10 "${sge_master_uri}" "${sge_master_port}"; then
return_is_sge_master_available="0"
debug_message "is_sge_master_available \
SGE Master (${sge_master_uri}:${sge_master_port}) is reachable from this host."
else
return_is_sge_master_available="1"
debug_message "is_sge_master_available \
SGE Master (${sge_master_uri}:${sge_master_port}) is not reachable from this host."
fi
return "${return_is_sge_master_available}"
}
# }}}
2020-06-15 13:49:25 +02:00
is_apt_upgrade_absent() { # {{{
## Count the number of upgradable packages and substract 1 for the header
2020-06-25 08:50:17 +02:00
local_apt_upgrade_number="$(apt list --upgradable 2>/dev/null \
2020-06-04 16:52:10 +02:00
| wc -l \
| awk '{print $1-1}')"
case "${local_apt_upgrade_number}" in
0 ) ## No available upgrade
return_apt_upgrade_absent="0"
;;
* ) ## Upgrade seems available
return_apt_upgrade_absent="1"
;;
esac
## Simple debug message to valid current variable
debug_message "is_apt_upgrade_absent \
APT upgrade available for this system: ${RED}${local_apt_upgrade_number:=/dev/null}${COLOR_DEBUG}."
return "${return_apt_upgrade_absent}"
}
# }}}
2020-06-15 13:49:25 +02:00
is_apt_upgrade_present() { # {{{
## Count the number of upgradable packages and substract 1 for the header
2020-06-25 08:50:17 +02:00
local_apt_upgrade_number="$(apt list --upgradable 2>/dev/null \
2020-06-04 16:52:10 +02:00
| wc -l \
| awk '{print $1-1}')"
case "${local_apt_upgrade_number}" in
0 ) ## No available upgrade
return_apt_upgrade_present="1"
;;
* ) ## Upgrade seems available
return_apt_upgrade_present="0"
;;
esac
## Simple debug message to valid current variable
debug_message "is_apt_upgrade_present \
APT upgrade available for this system: ${RED}${local_apt_upgrade_number:=/dev/null}${COLOR_DEBUG}."
return "${return_apt_upgrade_present}"
2021-04-12 09:13:00 +02:00
}
# }}}
is_file_present() { # {{{
local_file_present="${1}"
## File doesn't exist by default
return_is_file_present="1"
### Check if the file exists
# shellcheck disable=SC2086
if find ${local_file_present} > /dev/null 2>&1; then
return_is_file_present="0"
debug_message "is_file_present \
The file ${RED}${local_file_present}${COLOR_DEBUG} exists."
else
return_is_file_present="1"
debug_message "is_file_present \
The file ${RED}${local_file_present}${COLOR_DEBUG} doesn't exist."
fi
return "${return_is_file_present}"
}
# }}}
is_sge_slots_empty() { # {{{
if [ "${sge_slots_used}" -eq "0" ]; then
## Used slots is null
return_sge_slots_empty="0"
else
return_sge_slots_empty="1"
fi
## Simple debug message to valid current variable
debug_message "is_sge_slots_empty \
SGE slots currently in use: ${RED}${sge_slots_used:=/dev/null}${COLOR_DEBUG}."
return "${return_sge_slots_empty}"
}
# }}}
main() { # {{{
2021-01-26 18:23:01 +01:00
## If SGE is not yet available on this host {{{
### Exit
is_sge_host \
|| exit 0
## }}}
## Test if SGE Master is reachable {{{
### If sge_master_uri wasn't defined (environment variable,…) {{{
if [ -z "${sge_master_uri}" ]; then
## Use local host for sge_master_uri
sge_master_uri="physix-master.ipr.univ-rennes1.fr"
fi
### }}}
### If sge_master_port wasn't defined (environment variable,…) {{{
if [ -z "${sge_master_port}" ]; then
## Use local host for sge_master_port
sge_master_port="6444"
fi
### }}}
2021-01-26 20:02:22 +01:00
### If SGE Master is not reachable from this host {{{
#### Exit
is_sge_master_available \
|| exit 0
### }}}
## }}}
## Define all vars
define_vars
2020-09-24 14:56:27 +02:00
## If NO APT package upgrade is available {{{
### Ensure to remove any temp file related to APT upgrades
### AND Exit
is_apt_upgrade_absent \
&& rm -f -- "${APT_TMP_FILE}" \
&& exit 0
2020-09-24 14:56:27 +02:00
## }}}
2021-04-12 09:13:00 +02:00
## If APT temp file already exists {{{
### Exit
is_file_present "${APT_TMP_FILE}" \
&& exit 0
## }}}
## If SGE flag files already exists {{{
### Check if APT package upgrade is available
### Create APT temp file
### AND Exit
is_file_present "${sge_queue_flag_pattern}" \
&& is_apt_upgrade_present \
&& touch "${APT_TMP_FILE}" && echo "APT upgrade is available." >> "${APT_TMP_FILE}" \
&& exit 0
## }}}
## If EMPTY_ONLY_MODE is set {{{
### Verify empty slots
### OR Exit
if [ "${EMPTY_ONLY_MODE}" -eq "0" ]; then
### If SGE slots are not empty
### Exit
2020-09-25 15:08:51 +02:00
is_sge_slots_empty \
|| exit 0
fi
## }}}
2020-09-25 15:08:51 +02:00
## If APT package upgrade is available {{{
### Create APT temp file
### Disable SGE queue
### AND Exit
is_apt_upgrade_present \
&& touch "${APT_TMP_FILE}" && echo "APT upgrade is available." >> "${APT_TMP_FILE}" \
&& sh "${sge_disable_host_queue_script}" \
&& exit 0
## }}}
}
# }}}
2020-09-24 15:18:09 +02:00
# Manage arguments # {{{
# This code can't be in a function due to argument management
2020-09-24 15:18:09 +02:00
if [ ! "${NBARGS}" -eq "0" ]; then
manage_arg="0"
## If the first argument is not an option
if ! printf -- '%s' "${1}" | grep -q -E -- "^-+";
then
## Print help message and exit
printf '%b\n' "${RED}Invalid option: ${1}${RESET}"
printf '%b\n' "---"
usage
exit 1
fi
# Parse all options (start with a "-") one by one
while printf -- '%s' "${1}" | grep -q -E -- "^-+"; do
case "${1}" in
-d|--debug ) ## debug
2020-09-24 15:18:09 +02:00
DEBUG=0
;;
-e|--empty ) ## Empty only mode
2020-12-04 08:36:04 +01:00
EMPTY_ONLY_MODE="0"
;;
-h|--help ) ## help
2020-09-24 15:18:09 +02:00
usage
## Exit after help informations
exit 0
;;
* ) ## unknow option
2020-09-24 15:18:09 +02:00
printf '%b\n' "${RED}Invalid option: ${1}${RESET}"
printf '%b\n' "---"
usage
exit 1
;;
esac
debug_message "Arguments management \
${RED}${1}${COLOR_DEBUG} option managed."
## Move to the next argument
shift
manage_arg=$((manage_arg+1))
done
debug_message "Arguments management \
${RED}${manage_arg}${COLOR_DEBUG} argument(s) successfully managed."
else
debug_message "Arguments management \
No arguments/options to manage."
fi
# }}}
main
2020-06-15 13:49:25 +02:00
exit 255